<template>
  <v-card>
    <v-toolbar>
      <v-btn icon @click="$emit('close')">
        <v-icon>close</v-icon>
      </v-btn>
      <v-card-title>
        Add/edit proposal
      </v-card-title>
      <v-spacer/>
      <v-btn text @click="onSaveClick">Save</v-btn>
    </v-toolbar>

    <v-container>
      <h3 class="text-h3">General</h3>
      <v-form>
        <v-row no-gutters>
          <v-col cols="12" md="6">
            <v-select :items="countriesList" v-model="selectedCountry" @input="onChangeCountry">
              <template v-slot:label>
                <span>Country</span>
              </template>
              <template v-slot:selection="{ item }">
                <CountryFlag :country="item.iso"/>
                <span>{{ item.name }}</span>
              </template>
              <template v-slot:item="{item}">
                <CountryFlag :country="item.iso"/>
                <span>{{ item.name }}</span>
              </template>

            </v-select>
          </v-col>
        </v-row>
        <v-row no-gutters>
          <v-col cols="12">
            <v-textarea label="Conditions" v-model="currentItem.conditions"></v-textarea>
          </v-col>
        </v-row>
        <v-row no-gutters>
          <v-textarea label="Required documents" v-model="currentItem.documents"></v-textarea>
        </v-row>
      </v-form>
    </v-container>

    <v-container v-if="currentItem.workplace">
      <h3 class="text-h3">Workplace</h3>
      <v-form>
        <v-row>
          <v-col cols="6">
            <v-file-input label="Photo" accept="image/*"/>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="6" md="12" lg="6">
            <v-text-field label="Job title" v-model="currentItem.workplace.jobTitle"></v-text-field>
          </v-col>
          <v-col cols="6" md="12" lg="6">
            <v-text-field label="Company name" v-model="currentItem.workplace.companyName"></v-text-field>
          </v-col>
          <v-col cols="6" md="12" lg="6">
            <v-text-field label="Job address" v-model="currentItem.workplace.address"></v-text-field>
          </v-col>
          <v-col cols="6" md="12" lg="6">
            <v-text-field type="number" label="Approximate salary, HUF" min="0"
                          v-model="currentItem.workplace.salary"></v-text-field>
          </v-col>
          <v-col cols="12">
            <v-textarea label="Requirements & Terms" v-model="currentItem.workplace.conditions"></v-textarea>
          </v-col>
        </v-row>
      </v-form>
    </v-container>

    <v-container v-if="currentItem.accommodation">
      <h3 class="text-h3">Accommodation</h3>
      <v-form>
        <v-row>
          <v-col cols="6">
            <v-file-input label="Photo" accept="image/*"/>
          </v-col>
          <v-col cols="6" lg="6" md="12">
            <v-text-field label="Address" v-model="currentItem.accommodation.address"></v-text-field>
          </v-col>
          <v-col cols="6" md="12" lg="6">
            <v-text-field label="Monthly fee, HUF" type="number" min="0"
                          v-model="currentItem.accommodation.fee"></v-text-field>
          </v-col>

          <v-col cols="6" lg="6" md="12">
            <v-text-field label="Utilities, average, HUF" type="number" min="0"
                          v-model="currentItem.accommodation.utilities"/>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12">
            <v-textarea label="Description" v-model="currentItem.accommodation.conditions"></v-textarea>
          </v-col>
        </v-row>
      </v-form>
    </v-container>
  </v-card>
</template>

<script>
import CountryFlag from 'vue-country-flag';

const getItemTemplate = () => ({
  countryId: null,
  conditions: '',
  documents: '',

  workplace: {
    salary: 0,
    conditions: '',
    address: '',
    photoUrl: null,
    jobTitle: '',
    companyName: '',
  },

  accommodation: {
    fee: 0,
    utilities: 0,
    address: '',
    conditions: '',
    photoUrl: null,
  }
});


export default {
  name: "ProposalCreateEditPopup",
  components: {
    CountryFlag,
  },
  props: {
    proposal: Object,
    action: {
      type: String,
      default: 'create'
    }
  },
  methods: {
    onSaveClick() {
      this.$emit('update', {
        action: this.action,
        proposal: this.currentItem
      });
    },

    onChangeCountry(v) {
      this.currentItem.countryId = v.id;
    }
  },
  computed: {
    countriesList() {
      return this.$store.state.countries;
    }
  },
  watch: {
    action(v) {
      if (v === 'create') {
        this.currentItem = getItemTemplate();
      }
    },
    proposal(v) {
      if (this.action === 'edit') {
        this.currentItem = v;
      }
    }
  },
  data() {
    return {
      currentItem: getItemTemplate(),
      selectedCountry: null,
    }
  },
  mounted() {
    if (this.action === 'edit') {
      this.currentItem = JSON.parse(JSON.stringify(this.proposal));
      this.selectedCountry = this.countriesList.find(c => c.id === this.proposal.countryId);
    } else {
      this.currentItem = getItemTemplate();
    }
  }
}
</script>
